SystemOrganization addCategory: #UMLDiagramDrawing!

RectangleMorph subclass: #ConnectableBoundingBox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UMLDiagramDrawing'!

!ConnectableBoundingBox commentStamp: '<historical>' prior: 0!
A ConnectableBoundingBox is a bounding box with connection points for another morph that is going to be used as part of a graph or any diagram with connections between morphs (a class diagram, a sequence diagram, object diagram, etc)
!

!ConnectableBoundingBox methodsFor: 'connection points' stamp: 'carlaGriggio 7/28/2010 17:14'!
bottomConnectionPoint 
	^self connectionPoints fourth ! !

!ConnectableBoundingBox methodsFor: 'connection points' stamp: 'carlaGriggio 7/28/2010 10:58'!
connectionPoints
	^self submorphs ! !

!ConnectableBoundingBox methodsFor: 'accessing' stamp: 'carlaGriggio 7/28/2010 18:47'!
defaultColor
	^Color veryLightGray ! !

!ConnectableBoundingBox methodsFor: 'accessing' stamp: 'carlaGriggio 7/28/2010 11:03'!
delta
	^ 10! !

!ConnectableBoundingBox methodsFor: 'connection points' stamp: 'carlaGriggio 7/28/2010 18:51'!
initialize 
	super initialize.
	borderColor := Color gray.! !

!ConnectableBoundingBox methodsFor: 'connection points' stamp: 'carlaGriggio 7/28/2010 17:47'!
initializeConnectionPoints
"The use of these connection points might not be definitive, actually the spec is just a mock so I could use the connection points that way"
	"I'm still decoupling the project from Gaucho, so this will be different after I finish that"
	| top left right bottom |
	top := ConnectionPoint new position: (self positionAt: #top).
	left := ConnectionPoint new position: (self positionAt: #left).
	right := ConnectionPoint new position: (self positionAt: #right).
	bottom := ConnectionPoint new position: (self positionAt: #bottom).
	
	self
		addMorph: bottom;
		addMorph: right ;
		addMorph: left ;
		addMorph: top.! !

!ConnectableBoundingBox methodsFor: 'connection points' stamp: 'carlaGriggio 7/28/2010 17:14'!
leftConnectionPoint 
	^self connectionPoints second! !

!ConnectableBoundingBox methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 16:05'!
noteNewOwner: aMorph
	self bounds: owner bounds.
	self initializeConnectionPoints.! !

!ConnectableBoundingBox methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 16:08'!
positionAt: aPositionSymbol
	aPositionSymbol = #top ifTrue:[ ^ bounds topCenter - (self delta / 4 @ -1 )  ].
	aPositionSymbol = #bottom ifTrue:[ ^ bounds bottomCenter - (self delta / 2 @ self delta / 2) ].
	aPositionSymbol = #left ifTrue:[ ^ bounds left @ bounds center y  ].
	aPositionSymbol = #right ifTrue:[ ^ bounds right @ bounds center y - (self delta / 2 @ 0)  ].	! !

!ConnectableBoundingBox methodsFor: 'connection points' stamp: 'carlaGriggio 7/28/2010 17:14'!
rightConnectionPoint 
	^self connectionPoints third! !

!ConnectableBoundingBox methodsFor: 'connection points' stamp: 'carlaGriggio 7/28/2010 17:14'!
topConnectionPoint 
	^self connectionPoints first! !

!ConnectableBoundingBox methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 12:27'!
updateLayout
	self bounds: owner bounds.
	self connectionPoints do:[:each|
		each
			"position: ( self positionAt: each spec position );"
			updateView ].! !

!ConnectableBoundingBox methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 10:54'!
updateView
	self connectionPoints do:#updateView.
	self connectionPoints do:[:each|
		each inConnections do:#comeToFront.
		each outConnections do:#comeToFront].
! !

Morph subclass: #UMLConnectableMorph
	instanceVariableNames: 'titleBox'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UMLDiagramDrawing'!

UMLConnectableMorph subclass: #ClassBoxMorph
	instanceVariableNames: 'methodsBox variablesBox container classDescription methodsTextMorph boundingBox connections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UMLDiagramDrawing'!

!ClassBoxMorph class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/5/2010 02:56'!
forClassDescription: aClassDescription
	^self new classDescription: aClassDescription! !

!ClassBoxMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 04:06'!
addIncommingConnection: aConnection
	self addMorph: aConnection destinationHandle.! !

!ClassBoxMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 04:06'!
addOutcommingConnection: aConnection
	connections add: aConnection.
	self addMorph: aConnection.
	self addMorph: aConnection originHandle.! !

!ClassBoxMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 10:51'!
bottomConnectionPoint
	^boundingBox bottomConnectionPoint! !

!ClassBoxMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/4/2010 02:34'!
classDescription: aClassDescription
	classDescription := aClassDescription.
	
	classDescription ifNotNil: [classDescription removeDependent: self].
	aClassDescription ifNotNil: [aClassDescription addDependent: self].
	
	self updateTitle.
	self updateVariables.
	self updateMethods.
	self position: aClassDescription position.
	self updateBounds.! !

!ClassBoxMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 17:52'!
connectionPointNear: anotherClassBox
	self top > anotherClassBox bottom ifTrue:[^self bottomConnectionPoint].
	self bottom < anotherClassBox top ifTrue:[^self topConnectionPoint].
	self left > anotherClassBox right ifTrue:[^self leftConnectionPoint].
	self right < anotherClassBox left ifTrue:[^self rightConnectionPoint].
	^self leftConnectionPoint 
! !

!ClassBoxMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 03:34'!
connections 
	^connections ! !

!ClassBoxMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/1/2010 16:43'!
descriptionCode 
	^classDescription descriptionCode ! !

!ClassBoxMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 04:48'!
fontSize
	^13! !

!ClassBoxMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 04:47'!
formattedText: aText
	^aText addAttribute: (TextFontReference toFont: (StrikeFont familyName: 'Arial' size: self fontSize)); 
		yourself.
		! !

!ClassBoxMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/5/2010 22:33'!
initialize
	super initialize.
	self color: (Color r: 200 g: 200 b: 200).

	
	container:= self rectangle 
		color: Color transparent; 
		borderColor: Color transparent;
		cellInset: -2;
		listDirection: #topToBottom;
		position: self position.
	
	methodsBox := self rectangle.
	variablesBox := self rectangle.
	titleBox := self rectangle cellPositioning:  #topCenter.
	
	container addMorph: methodsBox ; addMorph: variablesBox   ; addMorph: titleBox.
	
	self addMorph: container.
	
	connections := Set new.

! !

!ClassBoxMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 17:52'!
leftConnectionPoint
	^boundingBox leftConnectionPoint! !

!ClassBoxMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 04:45'!
listFrom: aCollection
	^self formattedText: (aCollection asOrderedCollection joinUsing: String crlf) asText 
		! !

!ClassBoxMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 03:34'!
relations 
	^connections collect:[:conn | conn target]! !

!ClassBoxMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 10:51'!
rightConnectionPoint
	^boundingBox rightConnectionPoint ! !

!ClassBoxMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/7/2010 11:30'!
step
	! !

!ClassBoxMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 05:05'!
textMorphClass 
"was UpdaterTextMorph "
	^TextMorph    ! !

!ClassBoxMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 10:52'!
topConnectionPoint
	^boundingBox topConnectionPoint ! !

!ClassBoxMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 06:06'!
update: aParameter
	(aParameter == #variables)
		ifTrue: [self updateVariables].
	(aParameter == #methods)
		ifTrue: [self updateMethods].
	(aParameter == #position)
		ifTrue: [self position: ( owner position + classDescription position).].
	(aParameter == #title)
		ifTrue: [self updateTitle].	
	self updateBounds.
	 ! !

!ClassBoxMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/4/2010 04:28'!
updateBounds
	self bounds: container fullBounds.
	self extent: self extent + (7@0).
	boundingBox ifNil: [boundingBox := ConnectableBoundingBox new. self addMorph: boundingBox. boundingBox goBehind   ].
	
	boundingBox updateLayout.
	boundingBox updateView.! !

!ClassBoxMorph methodsFor: 'accessing' stamp: 'carlaGriggio 8/6/2010 04:37'!
updateMethods 

	| methodsMorph |
	methodsBox removeAllMorphs.
	
	methodsMorph := self textMorphClass new contents: (self listFrom: classDescription instanceMethods).
	methodsBox addMorph: methodsMorph.
		
	methodsMorph := self textMorphClass new contents: (self listFrom: classDescription classMethods).
	methodsBox addMorph: methodsMorph.
! !

!ClassBoxMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 03:33'!
updateRelationships
	self removeAllMorphsIn:  (self connections reject:[:subMorph | classDescription relations includes: subMorph target ]).
		
		
		! !

!ClassBoxMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 04:46'!
updateTitle  

	titleBox removeAllMorphs.
	titleBox addMorph: (StringMorph  new contents: (self formattedText: classDescription classNameForTitle asText)).
! !

!ClassBoxMorph methodsFor: 'accessing' stamp: 'carlaGriggio 8/6/2010 04:37'!
updateVariables 

	| variablesMorph |
	variablesBox   removeAllMorphs.
	
	(self listFrom: classDescription instanceVariables) ifNotEmpty:[
	variablesMorph := self textMorphClass new contents: (self listFrom: classDescription instanceVariables ).
	variablesBox  addMorph: variablesMorph.
	].
	
	(self listFrom: classDescription classInstanceVariables) ifNotEmpty:[
	variablesMorph := self textMorphClass new contents: (self listFrom: classDescription classInstanceVariables ).
	variablesBox addMorph: variablesMorph.
	].
	
	(self listFrom: classDescription classVariables) ifNotEmpty:[
	variablesMorph := UpdaterTextMorph new contents: (self listFrom: classDescription classVariables).
	variablesMorph acceptAction: [:text | self updateBounds. classDescription classVariables: (text findTokens: String cr)].
	variablesBox addMorph: variablesMorph.]
! !

UMLConnectableMorph subclass: #MessageSendMorph
	instanceVariableNames: 'durationMorph isInitialMessage sentMessageOrigin sentMessageDestination returnValueOrigin returnValueDestination sender returnValueMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UMLDiagramDrawing'!

!MessageSendMorph class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/4/2010 18:40'!
message: aSequenceMessage from: anObjectTimeline to: anotherObjectTimeline
	^self new initialize sender: anObjectTimeline ; message: aSequenceMessage toObject: anotherObjectTimeline  ! !

!MessageSendMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/4/2010 18:19'!
activityMorph
^ self rectangle
	 color: Color white;
	 borderColor: (Color r: 150 g: 150 b: 150);
	 borderWidth: 2;
	 width: 15;
	 height: 40;
	listDirection: #topToBottom;
	 useRoundedCorners.! !

!MessageSendMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/4/2010 19:07'!
addMessageSend: aMessageSend
	durationMorph addMorph: aMessageSend. 
	
	returnValueOrigin position:  durationMorph fullBounds bottomLeft - (0 @ 5) .
	returnValueDestination position: (self bottomLeft x @ (durationMorph fullBounds bottomLeft y - 5)) .
	returnValueMorph bottomRight: returnValueOrigin position.
	
	returnValueDestination updateView.
	returnValueOrigin updateView.! !

!MessageSendMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/4/2010 18:14'!
initialize 
	super initialize.
	self width: 15.
	self color: Color transparent.
	
	self isInitialMessage: false.
	
	durationMorph := self activityMorph.
	self addMorph: durationMorph.
	
	sentMessageOrigin := GMConnectionPoint new.
	sentMessageOrigin position: (self topLeft + ((durationMorph width / 2) @ 5)).
	
	
	! !

!MessageSendMorph methodsFor: 'accessing' stamp: 'carlaGriggio 7/3/2010 20:52'!
isInitialMessage
	^ isInitialMessage! !

!MessageSendMorph methodsFor: 'accessing' stamp: 'carlaGriggio 7/3/2010 20:52'!
isInitialMessage: anObject
	isInitialMessage := anObject! !

!MessageSendMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/4/2010 19:11'!
message: aSequenceMessage toObject: anObjectTimeline
	| messageLabelMorph |
	durationMorph position: ((anObjectTimeline distanceTo: sender)   @ self topLeft y).
	
	sentMessageDestination := GMConnectionPoint new.
	sentMessageDestination position: durationMorph topLeft + (0 @ 5).
	returnValueOrigin := GMConnectionPoint new.
	returnValueOrigin position: (durationMorph topLeft x @ (durationMorph bottomLeft y - 5)) .
	returnValueDestination := GMConnectionPoint new.
	returnValueDestination position: ((self topLeft x + (durationMorph width / 2)) @ (durationMorph bottomLeft y - 5)) .
	
	"self addMorph: sentMessageOrigin ; addMorph: returnValueOrigin .
	anObjectTimeline addMorph: sentMessageDestination ; addMorph: returnValueDestination ."
	
	self addMorph: (GMConnection newWithArrow lineWidth: 1; from: sentMessageOrigin to: sentMessageDestination ).
	self addMorph: (GMConnection newWithArrow lineWidth: 1; from: returnValueOrigin  to: returnValueDestination  ). 
	
	messageLabelMorph :=  (StringMorph new contents: aSequenceMessage message; bottomLeft: sentMessageOrigin position + (3 @ 0)  ).
	sentMessageOrigin addMorph: messageLabelMorph. self addMorph: messageLabelMorph.
	
	returnValueMorph:= StringMorph new contents: aSequenceMessage returnValue; bottomRight: returnValueOrigin position.
	returnValueOrigin addMorph: returnValueMorph. self addMorph: returnValueMorph 
	
	
	! !

!MessageSendMorph methodsFor: 'accessing' stamp: 'carlaGriggio 7/3/2010 21:54'!
sender: anObjectTimeline
	sender:= anObjectTimeline ! !

UMLConnectableMorph subclass: #TimelineMorph
	instanceVariableNames: 'timeline messagesMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UMLDiagramDrawing'!

!TimelineMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/4/2010 18:58'!
addMessageSend: aMessageSendMorph
	messagesMorph addMorph: aMessageSendMorph.
	timeline setVertices: 
		(Array 
			with: timeline firstVertex 
			with: ( timeline firstVertex x @ messagesMorph fullBounds bottomCenter y)).
		messagesMorph position: ((titleBox width / 2) - aMessageSendMorph width) @ (titleBox fullBounds bottom + 10)! !

!TimelineMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/3/2010 21:56'!
distanceTo: anotherMorph
	^self timelineAbscissa - anotherMorph timelineAbscissa! !

!TimelineMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/4/2010 18:57'!
initialize
	super initialize.
	self color: Color transparent.
	self borderColor: Color transparent.
	
	titleBox := self rectangle cellPositioning: #topCenter; height: 25..
	messagesMorph := self rectangle 
		color: Color transparent; 
		borderColor: Color transparent; 
		layoutPolicy: TableLayout new; 
		listDirection: #topToBottom; 
		cellInset: 0;
		cellSpacing: 0;
		width: 15; 
		position: (40@50).
	timeline := (PolygonMorph 
		vertices: (Array with: titleBox bottomCenter with: (titleBox bottomCenter + (0 @ 100)) )
	 	color: Color gray   
		borderWidth: 2
		borderColor: Color lightGray   )
			dashedBorder: { 5 . 10 . Color transparent . 0 . 0 }.
	
	self addMorph: timeline; addMorph: titleBox; addMorph: messagesMorph 
	

! !

!TimelineMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/3/2010 05:08'!
objectTitle: anObjectName
	|nameMorph|
	titleBox removeAllMorphs.
	nameMorph := (StringMorph new contents: anObjectName).
	titleBox addMorph: nameMorph.
	
	self width: nameMorph width + 15.
	titleBox  width: nameMorph width + 15.
	timeline setVertices: (Array with: titleBox fullBounds bottomCenter - (1 @ 0) with: ( titleBox bottomCenter  + (-1 @ 100)) ).
! !

!TimelineMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/3/2010 02:49'!
timelineAbscissa
	^titleBox bottomCenter x! !

!UMLConnectableMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/8/2010 05:52'!
initialize 
	super initialize.
	self clipSubmorphs: false.! !

!UMLConnectableMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/4/2010 04:29'!
rectangle 
	^RectangleMorph new 
		color: Color white; 
		borderColor: (Color r: 100 g: 100 b: 100);
		"width: 250;"
		layoutPolicy: TableLayout new;
		listDirection: #bottomToTop;
		cellPositioning:  #topLeft;
		hResizing: #spaceFill; 
		vResizing: #shrinkWrap;
		layoutInset: 5; cellInset: 2.! !

GMConnection subclass: #UMLConnection
	instanceVariableNames: 'handles label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UMLDiagramDrawing'!

!UMLConnection class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/7/2010 00:14'!
compositionDiamond
	^NCLineArrowGlyph openDiamond! !

!UMLConnection class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 19:18'!
fromRelation: anUMLRelation forDiagram: aDiagram
	! !

!UMLConnection class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/7/2010 00:04'!
newImplementationAssociation
	^self newInheritanceAssociation dashedLine: true! !

!UMLConnection class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/8/2010 06:16'!
newInheritanceAssociation
	^(self new)
		name: 'Inheritance';
		arrowNames: #(noArrow openArrow)! !

!UMLConnection class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/8/2010 06:15'!
newInstanceAssociation
	^(self new)
		name: 'Association';
		arrowNames: #(noArrow basicArrow)! !

!UMLConnection class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/7/2010 00:28'!
newInstanceComposition
	^(self new)
		name: 'Composition';
		arrowNames: #(quadDiamond noArrow)! !

!UMLConnection class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/7/2010 00:03'!
newInstanceUse
	^self newInstanceAssociation dashedLine: true! !

!UMLConnection class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/7/2010 00:31'!
newTraitsUse
	^(self new)
		name: 'Trait use';
		arrowNames: #(noArrow umlArrow);
		dashedLine: true! !

!UMLConnection methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/7/2010 19:26'!
addHandles 
	handles:= self handles.! !

!UMLConnection methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 20:31'!
clipSubmorphs 
	^false! !

!UMLConnection methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 20:24'!
destinationHandle 
	^self installedHandles second ! !

!UMLConnection methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 22:35'!
fitIntoDiagram: aDiagram
	self 
		from: ((aDiagram classBoxMorphFor: target classBoxOrigin ) connectionPointNear: (aDiagram classBoxMorphFor: target classBoxDestination))
		to: ((aDiagram classBoxMorphFor: target classBoxDestination) connectionPointNear: (aDiagram classBoxMorphFor: target classBoxOrigin )).
	(aDiagram classBoxMorphFor: target classBoxOrigin ) addOutcommingConnection: self.
	(aDiagram classBoxMorphFor: target classBoxDestination) addIncommingConnection: self.! !

!UMLConnection methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 20:23'!
from: origin to: destination 
	self vertices: {0@0. 10@10}.
	"origin attachTailOf: self .
	destination attachHeadOf: self. 
	self connectionPoints: {origin . destination }."
	self installedHandles ifEmpty: [self addHandles ].
	self installedHandles first center: origin center.
	self installedHandles second center: destination center.
	self updateView. ! !

!UMLConnection methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 12:24'!
handleForPosition: pos addAllowed: canAddVertex 
	"Answer a NCCurveHandleMorph that can be used to adjust me at the 
	given point."

	| v s curveInfo |
	curveInfo := self curveInfoNearest: pos.
	v := curveInfo vertexWithinProportion: 0.15
				andDistance: (40 max: self lineWidth / 2 + self borderWidth + 2).
	s := curveInfo closestBigSegment.
	v isZero 
		ifTrue: 
			[(canAddVertex or: [s = 1 or: [s = (vertices size - 1)]]) 
				ifTrue: 
					["Make a new vertex to edit"

					v := s + 1.
					self setVertices: (self vertices 
								copyReplaceFrom: v
								to: v - 1
								with: (Array with: pos))]
				ifFalse: 
					[^UMLCurveHandleMorph  new 
						target: self
						arguments: { 
								s}
						getPointSelector: #curveSegmentAt:
						setPointSelector: #curveSegmentAt:put:]].
	^UMLCurveHandleMorph new 
		target: self
		arguments: { 
				v}
		getPointSelector: #curveVertexAt:
		setPointSelector: #curveVertexAt:put:! !

!UMLConnection methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/8/2010 05:44'!
handles
	"Answer a collection of NCCurveHandleMorphs that can be used to adjust my vertices"
	^(1 to: vertices size) collect: [ :v |
		(UMLCurveHandleMorph new 
		target: self
		arguments: {  v}
		getPointSelector: #curveVertexAt:
		setPointSelector: #curveVertexAt:put:)
		]! !

!UMLConnection methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 20:11'!
installedHandles 
	^handles ifNil:[EmptyArray]! !

!UMLConnection methodsFor: 'accessing' stamp: 'carlaGriggio 8/6/2010 23:55'!
labelText: aByteString 

	label:=  (TransformationMorph new asFlexOf: (ImageMorph fromString: aByteString font: (TextFontReference toFont: ((StrikeFont familyName: 'Arial' size: 14)) ) font )).
	self addMorph: label.
	label position: label position + (15 @ -10).! !

!UMLConnection methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 20:18'!
originHandle 
	^self installedHandles first! !

!UMLConnection methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 03:40'!
target: aRelationship
	aRelationship label ifNotNil:[self labelText: aRelationship label].
	super target: aRelationship.
	! !

!UMLConnection methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 23:53'!
updateHeadVertex
	self verticesAt: vertices size put: self destinationHandle center.
	self updateLabel.! !

!UMLConnection methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 23:56'!
updateLabel
label ifNotNil:[
	label angle: ((self destinationHandle center y - self originHandle center y) arcTan: (self originHandle center x - self destinationHandle center x) ) -Float  pi.
	label position: self originHandle center + (15 @ -20)]
! !

!UMLConnection methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 23:54'!
updateTailVertex
	self verticesAt: 1 put: self originHandle center.
	self updateLabel.! !

!UMLConnection methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 23:53'!
updateView 
	self installedHandles ifEmpty: [self addHandles ].
	super updateView.! !

NCCurveHandleMorph subclass: #UMLCurveHandleMorph
	instanceVariableNames: 'connectionPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UMLDiagramDrawing'!

!UMLCurveHandleMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/9/2010 04:33'!
drawOn: aCanvas
	aCanvas frameAndFillRectangle: self bounds
		fillColor: self color
		borderWidth: 1
		borderColor: Color transparent ! !

!UMLCurveHandleMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 04:07'!
initialize
	super initialize.
	self extent: 15@15.
	self color: Color transparent .
"	self on: #mouseEnter send: #mouseOver: to: self.
	self on: #mouseLeave send: #mouseOut: to: self."! !

!UMLCurveHandleMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/9/2010 04:34'!
mouseOut: evt
	self color: Color transparent ! !

!UMLCurveHandleMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/9/2010 04:37'!
mouseOver: evt
	self color: (Color veryDarkGray alpha: 0.3)! !

!UMLCurveHandleMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 23:57'!
step
	desiredPoint := self center.
	self adjustCurve.
	self target updateLabel
	! !

!UMLCurveHandleMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 04:07'!
stepTime 
	^100! !

UMLShape subclass: #ConnectionPoint
	instanceVariableNames: 'connections outConnections inConnections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UMLDiagramDrawing'!

!ConnectionPoint methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 11:34'!
attachHeadOf: aConnector 
	inConnections add: aConnector .
	! !

!ConnectionPoint methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 11:34'!
attachTailOf: aConnector 
	outConnections add: aConnector .
	! !

!ConnectionPoint methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 17:54'!
borderColor
	^Color transparent! !

!ConnectionPoint methodsFor: 'accessing' stamp: 'carlaGriggio 7/28/2010 11:34'!
close 
	inConnections copy do:#close.
	outConnections copy do:#close.
! !

!ConnectionPoint methodsFor: 'accessing' stamp: 'carlaGriggio 7/28/2010 11:47'!
connectTo: anotherConnectionPoint
	| connector |
	connector := self connection from: self to: anotherConnectionPoint.
	^ connector ! !

!ConnectionPoint methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 12:18'!
connection
	^self factory connectionClass! !

!ConnectionPoint methodsFor: 'accessing' stamp: 'carlaGriggio 7/28/2010 11:34'!
connections
	^ inConnections , outConnections ! !

!ConnectionPoint methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 17:54'!
defaultBorderStyle 
	^ BorderStyle simple width: 1 ; color: self borderColor  .! !

!ConnectionPoint methodsFor: 'gaucho-created' stamp: 'carlaGriggio 7/28/2010 11:39'!
dettachFrom: aConnector 
	inConnections remove: aConnector ifAbsent:[ ].
	outConnections remove: aConnector ifAbsent:[].! !

!ConnectionPoint methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 12:18'!
factory
	^UMLFactory new! !

!ConnectionPoint methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 11:34'!
hasConnections
	^ ( inConnections isEmpty and:[ outConnections isEmpty ] ) not! !

!ConnectionPoint methodsFor: 'accessing' stamp: 'carlaGriggio 7/28/2010 11:34'!
inConnections
	^ inConnections ! !

!ConnectionPoint methodsFor: 'gaucho-created' stamp: 'carlaGriggio 7/28/2010 11:34'!
initialBounds
	^ 0@0 extent: 5@5.! !

!ConnectionPoint methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 11:34'!
initialize 
	inConnections := Set new.
	outConnections := Set new.
	super initialize .! !

!ConnectionPoint methodsFor: 'accessing' stamp: 'carlaGriggio 7/28/2010 11:34'!
outConnections
	^ outConnections ! !

!ConnectionPoint methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 11:34'!
position: aPoint 
	super position: aPoint.
	self updateView ! !

!ConnectionPoint methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 11:34'!
updateConnections 
	"inConnections do:[:each| each updateHeadVertex ].
	outConnections do:[:each| each updateTailVertex ]."
	self connections do:#updateView
	 ! !

!ConnectionPoint methodsFor: 'gaucho-created' stamp: 'carlaGriggio 7/28/2010 17:56'!
updateFillStyle 
	"self hasConnections not 
		ifTrue:[ self fillStyle: ( Color red alpha: 0.3)]
		ifFalse:[ self fillStyle: ( Color  green alpha: 0.3) ]"
	self fillStyle: Color transparent 
	
! !

!ConnectionPoint methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/28/2010 17:56'!
updateView 
	self
		updateFillStyle ;
		updateConnections.! !

!ConnectionPoint methodsFor: 'gaucho-created' stamp: 'carlaGriggio 7/28/2010 11:34'!
visible: aBoolean 
	super visible: aBoolean .
	outConnections do:[:each| each visible: aBoolean ].
	inConnections do:[:each| each visible: aBoolean  ].
! !

CategoryDiagramsHolder subclass: #ProfStefDiagrams
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UMLDiagramDrawing'!

!ProfStefDiagrams class methodsFor: 'accessing' stamp: 'carlaGriggio 8/7/2010 04:23'!
diagrams
	| diagramHolder |
	diagramHolder := self new.
	^ (self methodsInCategory: 'diagrams') collect: [ :selector | diagramHolder perform: selector ]! !

!ProfStefDiagrams methodsFor: 'diagrams' stamp: 'carlaGriggio 8/7/2010 04:23'!
tutorial
	| d profStef tutorialPlayer |
	profStef := ClassBox named: 'ProfStef'.
	profStef instanceVariables: #('lessonView' 'player' ).
	profStef instanceMethods: #('last' 'tutorial:lesson:' 'close' 'goOn:' 'first' 'next' 'go' 'tutorial:lessonAt:' 'player:' 'lessonView' 'showCurrentLesson' 'player' 'tutorialPositionString' 'lessonView:' 'open' 'previous' 'tutorialSizeString' ).
	profStef classInstanceVariables: #('instance' ).
	profStef classVariables: #('instance' ).
	profStef classMethods: #('last' 'tutorial:lesson:' 'goOn:' 'first' 'next' 'go' 'tutorial:lessonAt:' 'goOn:viewedWith:' 'initialize' 'default' 'goOn:viewedWith:player:' 'previous' 'contents' ).
	"Positioning"
	profStef position: 20 @ 0.
	tutorialPlayer := ClassBox named: 'TutorialPlayer'.
	tutorialPlayer instanceVariables: #('tutorialPosition' 'tutorial' ).
	tutorialPlayer instanceMethods: #('last' 'size' 'currentLesson' 'first' 'next' 'tutorial' 'tutorialPosition' 'rewind' 'previous' 'tutorialNode' 'tutorial:' 'tutorialPosition:' ).
	"Positioning"
	tutorialPlayer position: 480 @ 80.
	"Relationships"
	profStef hasA: tutorialPlayer labeledAs: 'player'.
	d := (ClassDiagram new name: 'Tutorial') addClassBoxDescription: profStef;
				 addClassBoxDescription: tutorialPlayer.
	^ d! !

TextMorph subclass: #UpdaterTextMorph
	instanceVariableNames: 'acceptAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UMLDiagramDrawing'!

!UpdaterTextMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/5/2010 01:29'!
acceptAction: aBlock 
	acceptAction := aBlock ! !

!UpdaterTextMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/31/2010 14:20'!
initialize 
	super initialize.
	! !

!UpdaterTextMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/5/2010 02:39'!
updateFromParagraph 
	super updateFromParagraph.
	acceptAction ifNotNil:[acceptAction value: self contents asString ].! !
